<?php
// Copyright 2013 borowicz.info nightly dev preview
// This file is part of esoTalk/plugin abShoutBOX. Please see the included license file for usage information.

if(!defined('IN_ESOTALK')) exit;

ET::$pluginInfo['abShoutBox'] = array(
	'name' => 'shoutBox',
	'description' => 'some simple chat based on jquery.',
	'version' => '0.1dev',
	'author' => 'borowicz.info',
	'authorEmail' => 'esotalk-plugins@borowicz.info',
	'authorURL' => 'http://borowicz.info',
	'license' => 'GPLv2'
);


class ETPlugin_abShoutBox extends ETPlugin {
	
	var $sb = array();
	var $url = '';

	public function handler_init($sender) 
	{
		$this->url = URL('?p=conversation/sb.json&userId='.ET::$session->userId.'&token='.ET::$session->token);
		$sender->addToMenu('meta', 'shoutBox', '<a href="#">'.T('shoutBox').'</a>');
		$sender->addJSFile($this->getResource("sb.js"));
		$sender->addCSSFile($this->getResource("sb.css"));
	}

	public function handler_conversationController_renderBefore($sender)
	{

	}
	
	public function handler_pageEnd($sender) 
	{
		if(ET::$session->userId && ET::$session->token && empty($sender->data['conversation']['conversationId']) && empty($sender->data['channelPath']) )
		{
			$out = '';
			$out = '
<script>
	var siteUrl = "'.URL().'";
	function sbRefresh()
	{
		setTimeout(sbRefresh,1500);
		sbReload("'.$this->url.'&reload=1",false);
	}
	if( $(document).ready() )
	{
		sbReload("'.$this->url.'&reload=1",true);
		$(function() {
			sbRefresh();
		});
	}
</script>
			<div id="shoutBox" class="sb-content">
				<div id="shoutBoxTitle">'.T('shoutBOX').'</div>
				<div id="shoutBoxMessages" class="sb-msg">
				</div>
				<form name="shoutBoxMessage" method="get" action="">
					<input name="sbm" type="text" id="sbm" />
					<input type="button" name="submitsmg" id="submitmsg" value="'.T('Send').'" onClick="sbSend(\''.$this->url.'\')" />
<a href="#" onClick="sbReload(\''.$this->url.'&reload=1\',false)" >reload</a>
<span class="sb-loading"></span>
				</form>
			</div>
			';
			echo $out;
		}
	}
	
	public function conversationController_sb($sender)
	{
		$sender->responseType = RESPONSE_TYPE_JSON;
		if(!$sender->validateToken() or !ET::$session->userId or ET::$session->isSuspended()) return;	
		
		if( isset($_GET['m']) )
		{
			$this->sb_sendShout();
		}
		else {
			$this->sb_loadData();
		}
		
		$sender->json("sb", $this->sb);
		$sender->render();
	}
	
	public function sb_sendShout()
	{
		ET::SQL()->insert("shoutbox")
			->set("memeberIp", $_SERVER['REMOTE_ADDR'])
			->set("memeberId", ET::$session->userId)
			->set("memeberName", ET::$session->user['username'])
			->set("shoutMessage", $_REQUEST['m'])
			->exec();	
	}	
	
	// Fetch latest 20 entries
	public function sb_loadData()
	{

		$result = ET::SQL()
				->select('idShout, shoutTime, memeberId, memeberName, shoutMessage')
				->from('shoutbox')
				->orderBy('idShout DESC')
				->limit('0,20')
				->exec();

		while($row = $result->nextRow()) {
			$this->sb[$row['idShout']] = array(
				'idShout' => $row['idShout'],
				'shoutTime' => $this->sb_timeShout($row['shoutTime']),
				'memeberId' => $row['memeberId'],
				'memeberName' => $row['memeberName'],
				'shoutMessage' =>$row['shoutMessage'],
			);
		} 
	}
	
	/*
	 * setup mysql
	 * check if exist
	 *
	 */
	public function sb_tableInit() 
	{
		$sql = 'CREATE TABLE IF NOT EXISTS '.ET::$database->tablePrefix.'shoutbox 
				(
idShout mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
shoutTime timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
memeberId mediumint(8) unsigned NOT NULL DEFAULT "0",
memeberIp varchar(12) COLLATE utf8_unicode_ci DEFAULT NULL,
memeberName tinytext COLLATE utf8_unicode_ci NOT NULL,
shoutMessage text COLLATE utf8_unicode_ci NOT NULL,
PRIMARY KEY(idShout)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1';
		ET::SQL($sql);

		$sql = 'INSERT IGNORE '.ET::$database->tablePrefix.'shoutbox(idShout, shoutTime, memeberId, memeberIp, memeberName, shoutMessage) VALUES(1, NOW(), 1, "127.0.0.1", "shoutBox deamon", "welcome on simple shout box by http://borowicz.info ");';
		ET::SQL($sql);
	}


	/*
	 * parse time 
	 * @todo parse today/yesterday etc
	 *
	 */
	public function sb_timeShout($dateTime)
	{
		$day = date("Y-m-d", strtotime($dateTime));
		$today = date("Y-m-d");
		if($day == $today) 
		{
			$dateTime = date("H:i", strtotime($dateTime));
		} 
		else {
			$dateTime = date("Y-m-d H:i", strtotime($dateTime));
		}
		return $dateTime;
	}

	//settings form.
	public function settings($sender)
	{
		$this->sb_tableInit();
/*
		$sb = C("plugin.abShoutBOX.conf", array());		
		$form = ETFactory::make("form");
		$form->action = URL("admin/plugins");
		
		$sender->data("abShoutBoxSettingsForm", $form);
		return $this->getView("settings");
*/
	}

}

?>